git: c978000da5c6 - stable/12 - Mount and unmount devfs around calls to add packages.

Warner Losh imp at FreeBSD.org
Thu Jul 8 05:51:22 UTC 2021


The branch stable/12 has been updated by imp:

URL: https://cgit.FreeBSD.org/src/commit/?id=c978000da5c6a909e16c0996a93d91068cafb03e

commit c978000da5c6a909e16c0996a93d91068cafb03e
Author:     Warner Losh <imp at FreeBSD.org>
AuthorDate: 2019-06-21 03:49:36 +0000
Commit:     Warner Losh <imp at FreeBSD.org>
CommitDate: 2021-07-08 05:51:03 +0000

    Mount and unmount devfs around calls to add packages.
    
    pkg now uses /dev/null for some of its operations. NanoBSD's packaging
    stuff didn't mount that for the chroot it ran in, so any config that
    added packages would see the error:
            pkg: Cannot open /dev/null:No such file or directory
    when trying to actually add those packages. It's easy enough for
    nanobsd to mount /dev and it won't hurt anything that was already
    working and may help things that weren't (like this). I moved the
    mount/unmount pair to be in the right push/pop order from the
    submitted patch.
    
    PR: 238727
    Submitted by: mike tancsa
    Tested by: Karl Denninger
    
    (cherry picked from commit 804b78634d543667a37ac459e692fe42c9dd30e8)
---
 tools/tools/nanobsd/defaults.sh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/tools/tools/nanobsd/defaults.sh b/tools/tools/nanobsd/defaults.sh
index 0002373be658..86acab65f67d 100755
--- a/tools/tools/nanobsd/defaults.sh
+++ b/tools/tools/nanobsd/defaults.sh
@@ -778,8 +778,9 @@ cust_pkgng ( ) (
 	# Mount packages into chroot
 	mkdir -p ${NANO_WORLDDIR}/_.p
 	mount -t nullfs -o noatime -o ro ${NANO_PACKAGE_DIR} ${NANO_WORLDDIR}/_.p
+	mount -t devfs devfs ${NANO_WORLDDIR}/dev
 
-	trap "umount ${NANO_WORLDDIR}/_.p ; rm -rf ${NANO_WORLDDIR}/_.p" 1 2 15 EXIT
+	trap "umount ${NANO_WORLDDIR}/dev; umount ${NANO_WORLDDIR}/_.p ; rm -rf ${NANO_WORLDDIR}/_.p" 1 2 15 EXIT
 
 	# Install pkg-* package
 	CR "${PKGCMD} add /_.p/${_NANO_PKG_PACKAGE}"
@@ -804,6 +805,7 @@ cust_pkgng ( ) (
 	CR0 "${PKGCMD} info"
 
 	trap - 1 2 15 EXIT
+	umount ${NANO_WORLDDIR}/dev
 	umount ${NANO_WORLDDIR}/_.p
 	rm -rf ${NANO_WORLDDIR}/_.p
 )


More information about the dev-commits-src-all mailing list